/*
 * Character.cpp
 *
 *  Created on: 28/mar/2012
 *      Author: bertini
 */

#include "Character.h"

#include <iostream>

using namespace std;

bool Character::operator ==( const Character& right ) const {
	if( HP != right.HP )
		return false;
	if( armor != right.armor )
		return false;

	return true;
}

int Character::getHP() const {
	return HP;
}

void Character::setHP(int hp) {
	this->HP = hp;
}

WeaponBehaviour Character::getWeapon() const {
	return weapon;
}

void Character::setWeapon(WeaponBehaviour weapon) {
	this->weapon = weapon;
}

int Character::getArmor() const {
	return armor;
}

void Character::setArmor(int defense) {
	this->armor = defense;
}

bool Character::fight(Character& enemy) {
	int hit = weapon.useWeapon();

	int damage = 0;
	if( hit > enemy.getArmor() ) {
		damage = enemy.receiveDamage(hit);
	}

	bool success = false;
	if( damage ) {
		cout << "Nemico colpito ! (ha ancora " << enemy.getHP() << " punti)"<< endl;
		success = true;
	}
	else
		cout << "Nemico mancato..." << endl;
	return success;
}

int Character::receiveDamage(int points) {
	if( armor > 4 )
		points /= 3;
	else
		points /= 2;
	if( points <= 0 )
		points = 1;

	HP -= points;

	return points;
}





